// #if !defined (UNITTEST)
#include "globals.h"
// #else
// #include "StdAfx.h"
// #endif

#include "TCommuSession.h"
#include "TPacket.h"
// #include "TProtocol.h"
// #include "debug.h"
#include <lmcons.h>		///< V{ UNLEN ̂߂Ɏgp

#define	OPENSERVER_MAX_RETRY		128
#include "../../common/modulepath.h"
#include "../../common/pipename.h"

WCHAR	CTCommunicateSession::m_rszSkkImePipeName [MAX_PATH] ;

/// @todo [Uł͂Ȃ[UIDgA^APIɈڍs
BOOL
CTCommunicateSession::bInitPipeName ()
{
	WCHAR		rszUserName [UNLEN + 1] ;
	ULONG		ulUserNameLen ;
	register LPWSTR		ptr ;

	ulUserNameLen	= countof(rszUserName) - 1 ;
	if (! GetUserNameW (rszUserName, &ulUserNameLen))
		return	FALSE ;
	rszUserName [UNLEN]	= L'\0' ;

	/*	VXe[U͍ȂcƂB
	 *
	 *	VXeƒʏ̃[U̓vZXԂL̂ŁA skkiserv
	 *	NƁAsystem ̃vtB[œĂ skkiserv Ɉʃ[
	 *	U query 邱ƂɂȂ...ʃ[U̐ݒ肪fȂȂ
	 *	܂B
	 *	``SYSTEM'' 炵ǁAcase ĔrB
	 */
	if (! lstrcmpiW (rszUserName, L"system"))
		return	FALSE ;

	ptr	= rszUserName ;
	while (*ptr != L'\0') {
		/*	pXƂĎgpłȂ͎̂̂ĂB*/
		if (*ptr == L'\\' || *ptr == L'*' || *ptr == L'?' ||
			*ptr == L':'  || *ptr == L'.' || *ptr == L'/') {
			*ptr = L'-' ;
		}
		ptr	++ ;
	}
	wnsprintfW (m_rszSkkImePipeName, countof(m_rszSkkImePipeName) - 1, SKKISERVER_PIPE_BASENAME, rszUserName) ;
	m_rszSkkImePipeName [countof(m_rszSkkImePipeName) - 1]	= L'\0' ;

	DEBUGPRINTF ((TEXT ("skimic: pipename = \"%s\"\n"), m_rszSkkImePipeName)) ;
	return	TRUE ;
}

HANDLE
CTCommunicateSession::_hOpenServer ()
{
	register HANDLE		hPipe ;
	register int		nRetry ;
	register BOOL		fServerStart ;

	hPipe			= INVALID_HANDLE_VALUE ;
	nRetry			= OPENSERVER_MAX_RETRY ;
	fServerStart	= FALSE ;
	for ( ; ; ) {
		register DWORD	dwError ;

		hPipe	= CreateFileW (m_rszSkkImePipeName, GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0) ;
		dwError	= GetLastError () ;
		if (hPipe != INVALID_HANDLE_VALUE) {
			break ;
		}
		if (dwError != ERROR_PIPE_BUSY) {
			DEBUGPRINTF ((TEXT ("CreateFileW failure (error:0x%lx)\n"), dwError)) ;
			/*	ERROR_FILE_NOT_FOUND ƂƂ́Askkiserv ȂAor
			 *	skkiserv  CreatePipe  server pipe 쐬ĂȂB
			 */
			if (dwError == ERROR_FILE_NOT_FOUND) {
				if (! fServerStart) {
					if (! _bStartServer ())
						break ;
					fServerStart	= TRUE ;
				}
				/*	skkiserv NĂ̂҂BSleep ȂƑq˂
				 *	sB
				 */
				Sleep (100) ;
				continue ;
			}
			/*	ERROR_FILE_NOT_FOUND ȊȌꍇɂ͑zOȂ̂ŔB*/
			break ;
		}
		/*	PIPE  BUSY łȂȂ̂҂BA҂
		 *	PIPE  BUSY łȂȂ̂ɐ䂪߂ȂƂ̂
		 *	(^C~OˑH)
		 *	莞Ԃŏ𔲂ABUSY Ȃēx҂AƂƂJ
		 *	ԂB
		 */
		if (WaitNamedPipeW (m_rszSkkImePipeName, 100) == 0) {
#if defined (DBG)
			dwError	= GetLastError () ;
			DEBUGPRINTF ((TEXT ("WaitNamedPipeW failed (0x%lx)\n"), dwError)) ;
#endif
			if (dwError != ERROR_SEM_TIMEOUT && dwError != ERROR_FILE_NOT_FOUND)
				break ;
		}
	}
	return	hPipe ;
}

BOOL
CTCommunicateSession::_bSend (
	register HANDLE			hPipe,
	register CTPacket*		pPacket)
{
	register const BYTE*	ptr ;
	register int		nptr ;
	DWORD				dwWrite ;

	ptr			= pPacket->pGetData () ;
	nptr		= pPacket->iGetDataSize () ;
	while (nptr > 0) {
		if (! WriteFile (hPipe, ptr, nptr, &dwWrite, NULL)) {
#if defined (DBG)
			DWORD	dwError	= GetLastError () ;
			DEBUGPRINTF ((TEXT ("_Send (data:%d) fail (%ld)\n"), nptr, dwWrite)) ;
#endif
			return	FALSE ;
		}
		ptr		+= dwWrite ;
		nptr	-= dwWrite ;
	}
	FlushFileBuffers (hPipe) ;
	return	TRUE ;
}

BOOL
CTCommunicateSession::_bRecv (
	register HANDLE		hPipe,
	register CTPacket*	pPacket)
{
	DWORD	dwRead ;

	if (! ReadFile (hPipe, pPacket->pGetData (), MSGBUFSIZE, &dwRead, NULL)) {
#if defined (DBG)
		DWORD	dwError	= GetLastError () ;
		DEBUGPRINTF ((TEXT ("_Recv () error (%ld)\n"), dwError)) ;
#endif
		return	FALSE ;
	}
	pPacket->vSetDataSize (dwRead) ;
	return	TRUE ;
}

BOOL
CTCommunicateSession::_bStartServer ()
{
	WCHAR					rszWindowsDir [MAX_PATH + 1] ;
	WCHAR					rszCmd [MAX_PATH + 1] ;
    STARTUPINFOW			si ;
    PROCESS_INFORMATION		pi ;
	register int			nWindowsDir, n ;
	register BOOL			fRetval ;

	nWindowsDir	= GetWindowsDirectoryW (rszWindowsDir, MAX_PATH) ;
	n			= (nWindowsDir < MAX_PATH)? nWindowsDir : MAX_PATH ;
#if defined (_MSC_VER) && (_MSC_VER >= 1400)
	rszWindowsDir [n]	= L'\0' ;
	wnsprintf (rszCmd, MYARRAYSIZE (rszCmd) - 1, TEXT("%s") SKKIME_APPLET_PRIVATESERVER, rszWindowsDir) ;
	rszCmd [MYARRAYSIZE (rszCmd) - 1]	= L'\0' ;
#else
	wcsncpy (rszCmd, rszWindowsDir, n) ;
	rszCmd [n]	= L'\0' ;
	wcsncpy (rszCmd + n, SKKIME_APPLET_PRIVATESERVER, MAX_PATH - n) ;
	rszCmd [MAX_PATH - 1]	= L'\0' ;
#endif

	ZeroMemory (&si, sizeof(si)) ;
	si.cb	= sizeof (si) ;

	/*	 pipename n\ɖ߂Ă݂B(PTNVQS())
	 *	Windows2000sp4  skkiserv  connect s錻ۂ̂ŁB
	 *	͂̏낤H
	 *	̂ skkiserv  pipename ɍĂƗ\zĂ鎞
	 *	if (! CreateProcessW (rszCmd, L"", NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi)) {
	 *	B
	 */
	if (! CreateProcessW (rszCmd, L"", NULL, NULL, FALSE, 0, NULL, rszWindowsDir, &si, &pi)) {
		fRetval	= FALSE ;
	} else {
		WaitForInputIdle (pi.hProcess, 3000) ;

		/* svɂȂnhB*/
		CloseHandle (pi.hProcess) ;
		CloseHandle (pi.hThread) ;
		fRetval	= TRUE ;
	}
	return	fRetval ;
}

