// #if !defined (UNITTEST)
#include "globals.h"
// #else
// #include "StdAfx.h"
// #endif

#include "dchar.h"

#if 1

DCHAR	todlower (DCHAR ch)
{
	return	(GET_UNICODE_PLANE(ch) == 0)? ((DCHAR)towlower ((WCHAR)GET_UNICODE_CODE(ch))) : ch ;
}

DCHAR	todupper (DCHAR ch)
{
	return	(GET_UNICODE_PLANE(ch) == 0)? ((DCHAR)towupper ((WCHAR)GET_UNICODE_CODE(ch))) : ch ;
}

BOOL	isdspace (DCHAR ch)
{
	return	(GET_UNICODE_PLANE(ch) == 0 && iswspace ((WCHAR)GET_UNICODE_CODE(ch))) ;
}

int	dcslen (LPCDSTR p)
{
	int	n = 0 ;

	while (*p != L'\0') {
		p	++ ;
		n	++ ;
	}
	return	n ;
}

int	dcsncmp (LPCDSTR p1, LPCDSTR p2, int n)
{
	while (n > 0 && *p1 == *p2 && *p1 != '\0') {
		p1	++ ;
		p2	++ ;
		n	-- ;
	}
	if (*p1 > *p2) {
		return	(int)(*p1 - *p2) ;
	} else {
		return	-(int)(*p2 - *p1) ;
	}
}

int	dcsnicmp (LPCDSTR p1, LPCDSTR p2, int n)
{
	while (n > 0 && todlower(*p1) == todlower(*p2) && *p1 != '\0') {
		p1	++ ;
		p2	++ ;
		n	-- ;
	}
	if (*p1 > *p2) {
		return	(int)(*p1 - *p2) ;
	} else {
		return	-(int)(*p2 - *p1) ;
	}
}

int dcscpy (LPDSTR pDest, LPCDSTR pSrc)
{
	while (*pSrc != L'\0') {
		*pDest ++	= *pSrc ++ ;
	}
	*pDest	= L'\0' ;
	return	0 ;
}

int	dcsncpy (LPDSTR pDest, LPCDSTR pSrc, int n)
{
	while (n > 0 && *pSrc != L'\0') {
		*pDest ++	= *pSrc ++ ;
		n	-- ;
	}
	if (n > 0)
		*pDest	= L'\0' ;
	return	0 ;
}

int	wcstodcs (LPDSTR pDest, int nDestSize, LPCWSTR pSrc, int nSrcLen)
{
	DCHAR*	pDestEnd ;
	LPCWSTR	ptr ;
	LPCWSTR	ptrEnd ;

	ptr			= pSrc ;
	ptrEnd		= pSrc + nSrcLen ;

	//	܂܎cobt@TCY0ƂɃobt@̕KvTCYԂƍB
	if (pDest == NULL && nDestSize == 0) {
		int		n ;
		n	= 0 ;
		while (ptr < ptrEnd) {
			if (ptr < ptrEnd && IS_SURROGATE_PAIR (*ptr, *(ptr+1))) {
//				DWORD	dw	= MAKE_DCHAR_FROM_SURROGATE_PAIR (*ptr, *(ptr+1)) ;
				n	++ ;
				ptr	+= 2 ;
			} else {
				n	++ ;
				ptr	++ ;
			}
		}
		return	n ;
	} else {
		const DCHAR*	pDestBak	= pDest ;

		pDestEnd	= pDest + nDestSize ;
		while (ptr < ptrEnd) {
			if (ptr < ptrEnd && IS_SURROGATE_PAIR (*ptr, *(ptr+1))) {
				if (pDest < pDestEnd)
					*pDest ++	= MAKE_DCHAR_FROM_SURROGATE_PAIR (*ptr, *(ptr+1)) ;
				ptr += 2 ;
			} else {
				if (pDest < pDestEnd)
					*pDest ++	= MAKE_DCHAR(0, *ptr) ;
				ptr	++ ;
			}
		}
		return	pDest - pDestBak ;
	}
}

static	HMODULE	s_hDLL		= NULL ;
static	BOOL	s_bNormaliz	= TRUE ;

int	wcstodcs_n (LPDSTR pDest, int nDestSize, LPCWSTR pSrc, int nSrcLen)
{
	LPWSTR	pBuffer	= NULL ;
	WCHAR	buf [256] ;
	int	nLength, nNeed,nRetval ;
	FARPROC	pProc ;

	//	 Normalize B
	if (s_hDLL == NULL) {
		if (! s_bNormaliz)
			goto	NonNormalizeExit ;

		s_hDLL	= LoadLibrary (TEXT ("Normaliz.dll")) ;
		if (s_hDLL == NULL) {
			s_bNormaliz	= FALSE ;
			goto	NonNormalizeExit ;
		}
	}
	pProc	= GetProcAddress (s_hDLL, "NormalizeString") ;
	if (pProc == NULL)
		goto	NonNormalizeExit ;
	nNeed	= ((int (WINAPI *)(NORM_FORM,LPCWSTR,int,LPWSTR,int))pProc)(NormalizationC, pSrc, nSrcLen, NULL, 0) ;
	if (nNeed < 0) {
//		DWORD	dwError	= GetLastError () ;
		goto	NonNormalizeExit ;
	}
	if (nNeed > MYARRAYSIZE (buf)) {
		pBuffer	= new WCHAR [nNeed] ;
	} else {
		pBuffer	= buf ;
	}
	nLength	= ((int (WINAPI *)(NORM_FORM,LPCWSTR,int,LPWSTR,int))pProc)(NormalizationC, pSrc, nSrcLen, pBuffer, nNeed) ;
	if (nLength < 0) {
//		DWORD	dwError	= GetLastError () ;

		if (pBuffer != buf)
			delete[]	pBuffer ;
		goto	NonNormalizeExit ;
	}
	nRetval	= wcstodcs (pDest, nDestSize, pBuffer, nLength) ;
	if (pBuffer != buf)
		delete []	pBuffer ;
	return	nRetval ;

NonNormalizeExit:
	return	wcstodcs (pDest, nDestSize, pSrc, nSrcLen) ;
}

int
dcstowcs (LPWSTR pwDest, int nDestSize, LPCDSTR pdSrc, int nSrcLen)
{
	LPCDSTR	ptr ;
	LPCDSTR	ptrEnd ;
	LPCWSTR	pwDestBak ;
	LPCWSTR	pwDestEnd, pwDestEnd_1 ;

	ptr		= pdSrc ;
	ptrEnd	= pdSrc + nSrcLen ;
	if (pwDest == NULL && nDestSize == 0) {
		int	n = 0 ;

		while (ptr < ptrEnd) {
			if (GET_UNICODE_PLANE (*ptr) == 0) {
				n	++ ;
			} else {
				n	+=2 ;
			}
			ptr	++ ;
		}
		return	n ;
	}

	pwDestBak	= pwDest ;
	pwDestEnd	= pwDest + nDestSize ;
	pwDestEnd_1	= pwDest + nDestSize - 1 ;

	while (ptr < ptrEnd && pwDest < pwDestEnd) {
		int	nPlane	= GET_UNICODE_PLANE (*ptr) ;
		if (nPlane == 0) {
			*pwDest ++	= (WCHAR) GET_UNICODE_CODE (*ptr) ;
		} else {
			if (pwDest < pwDestEnd_1) {
				*pwDest ++	= GET_HIGHSURROGATE_FROM_DCHAR (*ptr) ;
				*pwDest ++	= GET_LOWSURROGATE_FROM_DCHAR (*ptr) ;
			} else {
				break ;
			}
		}
		ptr	++ ;
	}
	return	pwDest - pwDestBak ;
}

/// dchar 𒲂ׂ
sizet dcsnlen(const DCHAR* p, sizet n)
{
	ASSERT(p || n == 0);
	ASSERT(n < 0x80000000);		///< @note 펯IȔ͈͓ł邱
	const DCHAR* r = p;
	const DCHAR* rEnd = p + n;
	while (r < rEnd && *r) r++;
	return (sizet)(r - p);
}

#else

////////////////////////////////////////////////////////////////////

/// dchar 啶
dchar todupper(dchar c)
{
#if 1
	// 2+Z1
	return (L'a' <= c && c <= L'z') ? c - (L'a' - L'A') : c;
#else
	// 1+R[+e[uQ+1+Z1
	return GET_UNICODE_PLANE(c) ? c : (dchar)towupper(GET_UNICODE_CODE(c));
#endif
}

/// dchar 
dchar todlower(dchar c)
{
#if 1
	return (L'A' <= c && c <= L'Z') ? c + (L'a' - L'A') : c;
#else
	return GET_UNICODE_PLANE(c) ? c : (dchar)towlower(GET_UNICODE_CODE(c));
#endif
}

/// dchar 󔒕̔
boolt isdspace(dchar c)
{
#if 1
	return c <= L' ';	/// @warning CRTłƂ͔قȂ̂Œ
#else
	return GET_UNICODE_PLANE(c) == 0 && iswspace(GET_UNICODE_CODE(c));
#endif
}

////////////////////////////////////////////////////////////////////

/*
/// dchar 𒲂ׂ
/// @warning ǂ܂łăy[WtHg\̂Œ
sizet dcslen(const dchar* p)
{
	ASSERT(p);
	const dchar* r = p;
	while (*r) r++;
	return (sizet)(r - p);
}
*/

/// dchar 𒲂ׂ
sizet dcsnlen(const dchar* p, sizet n)
{
	ASSERT(p || n == 0);
	ASSERT(n < 0x80000000);		///< @note 펯IȔ͈͓ł邱
	const dchar* r = p;
	const dchar* rEnd = p + n;
	while (r < rEnd && *r) r++;
	return (sizet)(r - p);
}

/// dchar ̔r
int	dcsncmp(const dchar* p1, const dchar* p2, sizet n)
{
	ASSERT(p1 || n == 0);
	ASSERT(p2 || n == 0);
	ASSERT(n < 0x80000000);		///< @note 펯IȔ͈͓ł邱
	int i = 0;
	while (n) {
		n--;
		dchar c = *p1++;
		i = c - *p2++;
		if (i || c == L'\0') break;
	}
	return i;
}

/// dchar ̔r (p啶ʂȂ)
int	dcsnicmp(const dchar* p1, const dchar* p2, sizet n)
{
	ASSERT(p1 || n == 0);
	ASSERT(p2 || n == 0);
	ASSERT(n < 0x80000000);		///< @note 펯IȔ͈͓ł邱
	int i = 0;
	while (n) {
		n--;
		dchar c = todlower(*p1++);
		i = c - todlower(*p2++);
		if (i || c == L'\0') break;
	}
	return i;
}

/*
/// dchar ̃Rs[
/// @warning ǂ܂łăy[WtHg\̂Œ
void dcscpy(dchar* pDst, const dchar* pSrc)
{
	ASSERT(pDst);
	ASSERT(pSrc);
	while (*pDst++ = *pSrc++);
}

/// dchar CӃTCỸ̕Rs[
/// @warning obt@Ezꍇ͏I[ĂȂ̂Œ
void dcsncpy(dchar* pDst, const dchar* pSrc, sizet n)
{
	ASSERT(pDst || n == 0);
	ASSERT(pSrc || n == 0);
	ASSERT(n < 0x80000000);		///< @note 펯IȔ͈͓ł邱
	// while (n-- && (*pDst++ = *pSrc++)) break;		// ܂ƂȃRpCȂ炱łOK
	while (n) {
		if ((*pDst = *pSrc) == L'\0') break;
		pDst++;
		pSrc++;
		n--;
	}
}
*/

/// dchar ̃Rs[
void dcscpy_s(dchar* pDst, sizet n, const dchar* pSrc)
{
	ASSERT(pDst || n == 0);
	ASSERT(pSrc || n == 0);
	ASSERT(n < 0x80000000);		///< @note 펯IȔ͈͓ł邱
	while (n > 1) {
		if ((*pDst = *pSrc) == L'\0') return;
		pDst++;
		pSrc++;
		n--;
	}
	if (n) *pDst = L'\0';
}

////////////////////////////////////////////////////////////////////

/// wchar 񂩂 dchar ւ̕ϊ
/**
dchar obt@(擪 pDstAőJEg nDst)
wchar (擪 pSrcAőJEg nSrc)TQ[gyAlĕg債]B
]ԂB
TQ[gyA dchar 1JEĝ wcslen ̒lƓɂȂȂꍇB

WCSTODCS_COUNT `̂:
	pDst  NULL ̏ꍇ͓]͍sȂ킸 pSrc ̕ԂB

ZLeBɊւāF
] pDst ɂāAnDst 0̏ꍇAK]̕͏I[B
] pSrc ɂāAnSrc z͈͈͂̃؃ANZXȂB
\[X̍Ōオobt@EŃTQ[gyÄꕶڂƂȂꍇ͂̕𖳎B
Rs[ƃRs[͈̔͂̕dȂ荇Ăꍇ͖̓`ƂĂB
@todo fobO͈̔͏dȂ`FbNR[hقȂB

@param	dchar* pDst			]
@param	sizet nDst			]őTCY
@param	const wchar* pSrc	]
@param	sizet nSrc			]őTCY (TQ[gyA2JEg)
@return	sizet 
*/
sizet wcstodcs(dchar* pDst, sizet nDst, const wchar* pSrc, sizet nSrc)
{
	ASSERT(pSrc || nSrc == 0);
	ASSERT(nSrc < 0x80000000);		///< @note 펯IȔ͈͓ł邱

	const wchar* r = pSrc;
	const wchar* rEnd = pSrc + nSrc;

#ifdef WCSTODCS_COUNT
	if (pDst == NULL) {
		// pSrc ̕ dchar PʂɊZĕԂ
		sizet n = 0;
		while (r < rEnd) {
			if (IS_SURROGATE_PAIR(r[0], r[1])) {
				r++;
				if (r >= rEnd) break;	// ͍==Eӂ100%Ô
			}
			r++;
			n++;
		}
		return n;
	}
#else	// WCSTODCS_COUNT
	ASSERT(pDst || nDst == 0);
	ASSERT(nDst < 0x80000000);		///< @note 펯IȔ͈͓ł邱
#endif	// WCSTODCS_COUNT

	dchar* w = pDst;
	const dchar* wEnd = pDst + nDst - 1;

	while (r < rEnd && w < wEnd) {
		if (IS_SURROGATE_PAIR(r[0], r[1])) {
			if (r + 1 >= rEnd) break;	// ͍==Eӂ100%Ô
			*w++ = MAKE_DCHAR_FROM_SURROGATE_PAIR(r[0], r[1]);
			r += 2;
			continue;
		}

		if (*r == L'\0') break;
		*w++ = MAKE_DCHAR(0, *r++);
	}
	if (w <= wEnd) *w = L'\0';

	return (sizet)(w - pDst);
}

/// dchar 񂩂 wchar ւ̕ϊ
/**
wchar obt@(擪 pDstAőJEg nDst)
dchar (擪 pSrcAőJEg nSrc)TQ[gyAlĕk]B
]ԂB
TQ[gyA wchar 2JEĝ wcslen ̒lƓɂȂȂꍇB

DCSTOWCS_COUNT `̂:
	pDst  NULL ̏ꍇ͓]͍sȂ킸 pSrc ̕ԂB

ZLeBɊւ:
] pDst ɂāAnDst 0̏ꍇAK]̕͏I[B
] pSrc ɂāAnSrc z͈͈͂̃؃ANZXȂB
\[X̍Ōオobt@EŃTQ[gyÄꕶڂƂȂꍇ͂̕𖳎B
Rs[ƃRs[͈̔͂̕dȂ荇Ăꍇ͖̓`ƂĂB
@todo fobO͈̔͏dȂ`FbNR[hقȂB

@param	wchar* pDst			]
@param	sizet nDst			]őTCY (TQ[gyA2JEg)
@param	const dchar* pSrc	]
@param	sizet nSrc			]őTCY
@return	sizet 
*/
sizet dcstowcs(wchar* pDst, sizet nDst, const dchar* pSrc, sizet nSrc)
{
	ASSERT(pSrc || nSrc == 0);
	ASSERT(nSrc < 0x80000000);		///< @note 펯IȔ͈͓ł邱

	const dchar* r = pSrc;
	const dchar* rEnd = pSrc + nSrc;

#ifdef DCSTOWCS_COUNT
	if (pDst == NULL) {
		// pSrc ̕ wchar PʂɊZĕԂ (TQ[gyA2JEg)
		int n = 0;
		while (r < rEnd) {
			if (GET_UNICODE_PLANE(*r++)) n++;
			n++;
		}
		return n;
	}
#else	// DCSTOWCS_COUNT
	ASSERT(pDst || nDst == 0);
	ASSERT(nDst < 0x80000000);		///< @note 펯IȔ͈͓ł邱
#endif	// DCSTOWCS_COUNT

	wchar* w = pDst;
	const wchar* wEnd = pDst + nDst - 1;

	while (r < rEnd && w < wEnd) {
		dchar c = *r++;
		if (c == L'\0') break;
		if (GET_UNICODE_PLANE(c)) {
			if (w + 1 >= wEnd) break;
			*w++ = GET_HIGHSURROGATE_FROM_DCHAR(c);
			*w++ = GET_LOWSURROGATE_FROM_DCHAR(c);
			continue;
		}
		*w++ = GET_UNICODE_CODE(c);
	}
	if (w <= wEnd) *w = L'\0';

	return	(sizet)(w - pDst);
}

////////////////////////////////////////////////////////////////////

/// dchar 𒲂ׂ (ő4096܂)
sizet dcslenX(const dchar* p)
{
	return dcsnlen(p, 4096);
}

/// dchar ̃Rs[ (ő4096܂)
void dcscpyX(dchar* pDst, const dchar* pSrc)
{
	dcscpy_s(pDst, 4096, pSrc);
}

////////////////////////////////////////////////////////////////////

#endif
